program Regressi;


uses
  Forms,
  oneinst in 'oneinst.pas',
  keysu in 'keysu.pas',
  constreg in 'constreg.pas',
  maths in 'maths.pas',
  regutil in 'regutil.pas',
  uniteker in 'uniteker.pas',
  fft in 'fft.pas',
  statcalc in 'statcalc.pas',
  systdiff in 'systdiff.pas',
  regmain in 'regmain.pas' {FRegressiMain},
  optcolordlg in 'optcolordlg.pas' {OptionCouleurDlg},
  optfft in 'optfft.pas' {OptionsFFTDlg},
  supprdlg in 'supprdlg.pas' {SuppressionDlg},
  lecttext in 'lecttext.pas' {LectureTexteDlg},
  optline in 'optline.pas' {OptionLigneDlg},
  zoomman in 'zoomman.pas' {ZoomManuelDlg},
  newvar in 'newvar.pas' {NewVarDlg},
  graphker in 'graphker.pas',
  statisti in 'statisti.pas' {Fstatistique},
  filerrr in 'filerrr.pas',
  curmodel in 'curmodel.pas' {CurseurModeleDlg},
  options in 'options.pas' {OptionsDlg},
  modelegr in 'modelegr.pas',
  choixtang in 'choixtang.pas' {ChoixTangenteDlg},
  graphpar in 'graphpar.pas' {fgrapheParam},
  graphvar in 'graphvar.pas' {FgrapheVariab},
  cursdata in 'cursdata.pas' {ReticuleDataDlg},
  pagecopy in 'pagecopy.pas' {PageCopyDlg},
  selpage in 'selpage.pas' {SelectPageDlg},
  pagecalc in 'pagecalc.pas' {PageCalcDlg},
  varkeyb in 'varkeyb.pas' {NewClavierDlg},
  regprint in 'regprint.pas' {PrintDlg},
  identPages in 'identPages.pas' {ChoixIdentPagesDlg},
  statopt in 'statopt.pas' {StatOptDlg},
  modif in 'modif.pas' {ModifDlg},
  valeurs in 'valeurs.pas' {FValeurs},
  choixmodeleGlb in 'choixmodeleGlb.pas' {ChoixModeleGlbDlg},
  choixparamanim in 'choixparamanim.pas' {AnimParamDlg},
  coordphys in 'coordphys.pas' {FcoordonneesPhys},
  affectenom in 'affectenom.pas' {AffecteNomDlg},
  saveparam in 'saveparam.pas' {SaveParamDlg},
  optionsvitesse in 'optionsvitesse.pas' {OptionsVitesseDlg},
  regdde in 'regdde.pas' {FormDDE},
  selparam in 'selparam.pas' {selParamDlg},
  origineu in 'origineu.pas' {OrigineDlg},
  cornish in 'cornish.pas' {Fcornish},
  cornopt in 'cornopt.pas' {CornishOptDlg},
  choixmodele in 'choixmodele.pas' {ChoixModeleDlg},
  optModele in 'optModele.pas' {OptionModeleDlg},
  compile in 'compile.pas',
  addPageExp in 'addPageExp.pas' {AddPageExpDlg},
  ZoomManuelFFT in 'ZoomManuelFFT.pas' {ZoomManuelFFTdlg},
  indicateurU in 'indicateurU.pas' {indicateurDlg},
  saveHarm in 'saveHarm.pas' {SaveHarmoniqueDlg},
  constante in 'constante.pas' {ConstanteUnivDlg},
  fspec in 'fspec.pas',
  savePosition in 'savePosition.pas' {SavePositionDlg},
  PropCourbe in 'PropCourbe.pas' {PropCourbeForm},
  about in 'about.pas' {AboutBox},
  graphfft in 'graphfft.pas' {FGrapheFFT},
  Latex in 'Latex.pas',
  latexreg in 'latexreg.pas' {LatexDlg},
  aideKey in 'aideKey.pas',
  OptionsAffModeleU in 'OptionsAffModeleU.pas' {OptionsAffModeleDlg},
  WavMain in 'Images\WavMain.pas' {WaveForm},
  TestInWav in 'Images\TestInWav.pas' {TestWavDlg},
  grapheu in 'Images\grapheu.pas',
  Dynamic_Bass in 'Images\Dynamic_Bass.pas',
  FusionU in 'FusionU.pas' {FusionDlg},
  ChronoBitmap in 'Images\ChronoBitmap.pas' {ChronoForm},
  ChronoEch in 'Images\ChronoEch.pas' {EchelleMecaBmpDlg},
  CourbesU in 'Images\CourbesU.pas' {CourbesForm},
  courbesEch in 'Images\courbesEch.pas' {EchelleBmpDlg},
  selColonne in 'selColonne.pas' {SelectColonneDlg},
  pageechant in 'pageechant.pas' {PageEchantillonDlg},
  interfMain in 'Images\interfMain.pas' {OptiqueForm},
  VclMain in 'Images\VclMain.pas' {VclForm},
  PasLibVlcClassUnit in 'Images\PasLibVlcClassUnit.pas',
  PasLibVlcPlayerUnit in 'Images\PasLibVlcPlayerUnit.pas',
  PasLibVlcUnit in 'Images\PasLibVlcUnit.pas',
  savemodele in 'savemodele.pas' {SaveModeleDlg},
  VLC_3D in 'Images\VLC_3D.pas' {VLC_3DForm},
  stayontop_3D in 'Images\stayontop_3D.pas' {Draw_3DForm},
  graph3D in 'graph3D.pas' {fgraphe3D},
  coord3D in 'coord3D.pas' {Fcoordonnees3D},
  VLCbitmap in 'Images\VLCbitmap.pas' {VLCBitmapForm},
  stayontopVcl in 'Images\stayontopVcl.pas' {DrawForm},
  arduinoU in 'arduinoU.pas' {ArduinoForm},
  ArduinoCfg in 'ArduinoCfg.pas' {ArduinoDlg},
  ChronoU in 'Images\ChronoU.pas' {VLCChronoForm},
  conversion in 'Images\conversion.pas' {ConversionForm},
  aviMain in 'Images\aviMain.pas' {AviForm},
  pagedistrib in 'pagedistrib.pas' {PageDistribDlg},
  arduinoOscillo in 'arduinoOscillo.pas' {ArduinoOscilloForm},
  ArduinoOscilloCfg in 'ArduinoOscilloCfg.pas' {ArduinoOscilloDlg},
  coordEuler in 'coordEuler.pas' {FcoordonneesEuler},
  graphEuler in 'graphEuler.pas' {FgrapheEuler},
  bass in 'Images\bass.pas',
  mathml_Presentation in 'mathml_Presentation.pas',
  loupeU in 'Images\loupeU.pas' {LoupeForm},
  stayontopAvi in 'Images\stayontopAvi.pas' {AviDrawForm},
  hdf5dll in 'hdf5dll.pas',
  modeleNum in 'modeleNum.pas',
  RollingShutterU in 'Images\RollingShutterU.pas' {RollingShutterForm},
  RollingShutterCalc in 'Images\RollingShutterCalc.pas';

{$R *.RES}

begin
  Application.Title := 'Regressi';
  Application.HelpFile := '';
  Application.MainFormOnTaskbar := True;
  Application.CreateForm(TFRegressiMain, FRegressiMain);
  Application.CreateForm(TOptionsDlg, OptionsDlg);
  Application.CreateForm(TFormDDE, FormDDE);
  Application.CreateForm(TChoixModeleDlg, ChoixModeleDlg);
  Application.CreateForm(TindicateurDlg, indicateurDlg);
  Application.CreateForm(TConstanteUnivDlg, ConstanteUnivDlg);
  Application.CreateForm(TFcoordonneesPhys, FcoordonneesPhys);
  Application.Run;
end.
