unit constreg;

interface

uses
  SysUtils, Windows;

const
   crLF = #10;
   crESC = #27;
   crCR = #13;
   stCalculSI : array[boolean] of string = ('Calcul SANS prise en compte des coefficients d''unit',
                                            'Calcul AVEC prise en compte des coefficients d''unit');
   stOuiNon : array[boolean] of string = ('Non','Oui');
   stActive : array[boolean] of string = ('|Page inactive','|Page active');

resourcestring

stNewPage = 'Nouvelle page';
stIntervalle95 = 'Intervalle de confiance  95%';
stIncertitudeType = 'Incertitude-type';
erProgAcqDialog = 'Impossible de dialoguer (DDE) avec ';
okPageVersCol = 'Transformer les pages en colonnes';
okNonNum = 'Utilisation d''une grandeur non numrique';
erNotExists = ' n''existe plus';
erNonNum = 'Variable non numrique';
erEffectifNotInt = 'Effectif non entier !';
erPourCent = 'Somme des frquences diffrente de 100 !';
erFrameRate = 'Nombre de trames par seconde incorrecte';

erEchelle  = 'Echelle incorrecte';
erPbImprimante='Impossible de se connecter (HP LaserJet 1600 ?)';
erPageModele='Syntaxe : y[numero de page]=f(x)';
erNomVide='Nom vide';
erNomGrandeurVide='Pas de nom de variable  affecter';
erDebutNom='Un nom doit commencer par une lettre';
erNomInterdit='Nom interdit (j^2=-1 pi=3.1416)';
erNomFonction='Nom interdit (nom de fonction : Im Re Arg Min Max...)';
erNomExistant='Nom interdit (dj existant)';
erMuette='Nom interdit pour une variable muette (dj existant)';
erVarTexte='Calcul impossible avec une grandeur texte';
erDoubleOperateur='Deux oprateurs  la suite : ';
erUnite='Unit incorrecte';
erAire='''->La fonction aire(x,y) dtermine l''aire d''une surface ferme';
erNbreVarInf2='Pas assez de variables';
erFileNotExist='Fichier non trouv';
erCaracNom='Caractre interdit dans un nom';
erParamModeleVersExp='Utilisation d''un paramtre de modlisation (donc susceptible de disparatre)';
erNbreGradManuel='Nombre de graduations <2 ou >64 => retour au mode automatique';
erOrtho='Vrifier l''option "orthonorm" (boite de dialogue coordonnes)';
erInv='Vrifier la graduation inverse (boite de dialogue coordonnes)';
erExpressionVide='Expression vide';
erTexteNotTest='Texte en dehors d''un IF';
erFonctionNil='Fonction non initialise';
erNombrePetit='Modlisation impossible : nombre de valeurs < nombre de paramtres';
erVide='Expression vide';
erNombre='Nombre mal crit';
erTropLong='Identificateur trop long';
erInterne='Erreur interne';
erTropComplexe='Expression trop complique';
erParF='Manque )';
erParO='Manque (';
erParamSolve='Manque un paramtre : solve(equation,min,max)';
erParamMoyenne='Manque un paramtre : mean(variable,debut,fin)';
erVarInterdite='Variable interdite';
erParamInterdit='Paramtre interdit';
erTropParam='Trop de paramtres';
erVirgule='Manque ,';
erVarAttendue='Variable attendue';
erFonctNonCpx='Fonction interdite dans les complexes';
erOperNonCpx='Operateur interdit dans les complexes';
erReel='Le rsultat doit tre rel (Re;Im;Arg;Abs)';
erSyntaxe='Erreur de syntaxe';
erSyntaxeModele='Syntaxe du modle : Y(X)=f(X)';
erSyntaxeIncert='Syntaxe de l''incertitude type : u(X)';
erVarInconnue='Variable non reconnue';
erDomaine='Fonction hors de son domaine de dfinition';
erDivergence='Divergence de la modlisation';
erTimeOut='Arrt de la modlisation au bout de 32 itrations';
erPageCalc='Pas de zone commune entre les diffrentes pages';
erNombreVar='Pas assez de variables';
erDerNonDef='Drive non dfinie';
erSyst1Var='Systme d''qua diff ncessite la mme variable explicative';
erNonInstallee ='Fonction non installe';
erVarDef='Grandeur dj dfinie';
erMaxModele='Nombre maximum de modles : 4';
erEgalAbsent='Syntaxe des fonctions : nom=''expression';
erCaracInterdit='Caractre interdit';
erGenreModele='Les modles doivent tre de mme type : fonction OU qua. diff. d''ordre 1 OU 2';
erVarOrNombre='Doit tre un paramtre ou une valeur numrique';
erModeleGlb='Modlisation par fonction uniquement dans l''espace des paramtres';
erCrochet='[] interdit y[min] de Regressi DOS remplac par min(y)';
erCurseurModele='Modlisation non accessible';
erNmesInf16='Nombre de points trop faibles <16';
erFormat='Format fichier incorrect';
erConst3D ='Crochets non permis';
erFonctionPageNonPermis ='Fonction page[n] non permise';
erParamInconnu ='Paramtre inconnu';
erGrandTableau ='Impression de grand tableau interdite';
erXOR='Oprateur interdit en dehors de IF';
erFileAdd='Erreur  la lecture du fichier';
erFileLoad='Impossible d''ajouter le fichier';
erModeleGr='Donnes non cohrentes avec le modle';
erInitAdefinir='Donnez une valeur initiale dans l''onglet paramtres';
erConstNonDef='Valeur de paramtre exprimental absente';
erParamAdefinir='Donnez une valeur aux paramtres';
erSuperGlb='Superposition de fonction en construction';
erCurseurTangente='Impossible : abscisse<>premire variable';
erGradNonLineaire='Impossible : graduations non linaires';
erPrimeRRR='Caractre '' interdit dans les variables (rserv aux qua. diffrentielles)';
erDiffSimul='Le nombre maxi d''quations dans un systme est de ';
erEcart='Ecart modle-exprience trs grand vrifier vos paramtres';
erFonctionGlbIsole ='Les fonctions Intg Diff Harm Filtre ... doivent tre utilises isolment';
erVarFreq='Nom rserv pour les sries de Fourier';
erPlotter='Installer un traceur dans le panneau de configuration d''imprimantes';
erColPrinter='Nombre de colonnes trop grand : penser au mode paysage ou au couper-coller';
erBadDataNom='Donnes incompatibles : noms diffrents';
erSuperposePage='Positionnement de l''origine une page  la fois';
erBadDataInf='Donnes incompatibles : trop de grandeurs';
erBadDataSup='Donnes incompatibles : trop de grandeurs';
erSyntaxeDDE='Syntaxe Macro DDE : Fonction(Paramtre)';
erDDEone='Un message DDE  la fois SVP';
erPuissEnt='Puissance non entire';
erPointModele='Un point non pris en compte : n';
erDiff0='La variable explicative des qua. diff. est la premire colonne';
erRemplitLog='Remplissage exponentiel avec valeur <= 0';
erModeleSystDiff='Systme diff. uniquement';
erFileData='Donnes du fichier incorrectes';
erProgAcq='Programme d''acquisition inconnu';
erDDE='Liaison DDE impossible avec ';
erIndexNotVariab ='Interdit en dehors des variables';
erCrochetF ='] attendu';
erPosMin ='Posmin; posmax remplacs par pos(variable;quation;[up|down|mini|maxi])';
erTangenteAgauche ='L''axe doit tre  gauche';
erOrigineExp ='Modification uniquement pour grandeur exprimentale';
erModeleIncorrect ='Dsactiver le mode superposition de pages';
erWriteFile ='Erreur d''criture du fichier';
erReadFile ='Erreur de lecture du fichier';
erReadVotable ='N''est pas un fichier Votable';
erReadRegressiXML ='N''est pas un fichier Regressi XML';
erDOMXML = 'Parser XML non trouv';
erPostScript ='Ne peut crer *.EPS';
erFonctionPage ='page(nombre)';
erOriginePage ='Ncessite une seule page active';
erExposantCpx ='Exposant uniquement entier  l''intrieur des complexes';

OkDelFile='Ecraser le fichier existant';
OkImprGr='Impression du graphe';
OkImprTab='Impression des tableaux';
OkDelData='Suppression des donnes slectionnes';
OkDelAll='Effacement de la page courante';
OkUniteInconnue='Unit non reconnue vous confirmez ?';
OkNoParamAuto='Pas d''expression. Dsactiver gnration auto ?';
OkVarTri='Garder %s comme variable trie';
OkSauve='Sauvegarde de l''tat courant ?';
OkMobile2='Deuxime mobile ?';
OkDelPage='Suppression de la page n%s';
OkModifGr='Modification du graphe selon modle ?';
OkImprModele='Impression de la modlisation';
OkInitParam='Initialisation des paramtres ?';
OkDelVariab='Ecraser l''ancienne variable %s';
OkBadDataNom='Donnes incompatibles (noms diffrents) on continue ?';
OkBadDataNewFile='Donnes incompatibles avec les donnes courantes => Crer un nouveau fichier ?';
OkImprTabVariab='Impression du tableau des variables';
OkModifOrigine='Effectuer le changement d''origine ?';
OkImprCurseur ='Impression des valeurs modlises';
OkAngleDegre ='Angle en degr';
OkAngleRadian ='Angle en radian';
OkNotUniteSI ='Non prise en compte des coeff. d''unit';
OkuniteSI ='Prise en compte des coeff. d''unit';
OkPaysage ='Impression avec orientation paysage';
okSupprIdentCoord ='Suppression des identifications de courbes';

trFiltreModele ='Modlisation (*.mod)|*.mod';
trFiltreWMF ='Metafichier Windows (*.emf)|*.emf';
trFiltreExe ='Excutable (*.exe)|*.exe|Batch (*.bat)|*.bat';
erPrefixe ='Essayer de travailler en S.I. sans prfixe m k ... (sauf kg !)';
erUneLigneSurN ='Impression d''une ligne sur %s';
erAxeLog ='Axe log. ou dB impossible : valeurs <= 0 ?';
erDiff2 ='Equation diffrentielle d''ordre 1 ou 2';
hSupprPointActif ='|Suppr : suppression du point cliqu ; barre : dsactivation du point';
hSupprPointNonActif ='|Suppr : suppression du point cliqu ; barre : activation du point';
hMove ='|Cliquer/dplacer pour modification de la position du zoom';
hValeurModele ='|Entrez une valeur et validez pour calculer';
hGlisser ='|Glisser pour dplacer';
hDbleTexte ='Clic droit pour modifier le texte ou supprimer';
hDbleCouleur ='Clic droit pour choix de couleur/style de la ligne ou suppression';
hOrigineGraphe ='|Positionner la verticale  la nouvelle origine puis cliquer';
hAxeX ='|Modifier l''orientation de l''axe "horizontal"';
hAxeY ='|Modifier l''orientation de l''axe "vertical"';
hSegment ='|Cliquer  l''intersection du rticule puis faire glisser'+crCR+crLF+
          'F10:enregistre la position courante ; ESC=fin';
hReticuleModele ='|Cliquer  l''intersection du rticule puis faire glisser'+crCR+crLF+
                 'F10:enregistre la position courante ; ESC=fin';
hCurseurFrequence ='|F10:enregistre la position courante';
hClicDroit ='|Utiliser le clic droit pour ouvrir le menu local';
hHistoResidu ='Histogramme des rsidus';
hExpFFT ='|Tapez une expression fonction de %s uniquement';
hindice ='%s va de 0  %s-1';
hEuler =' signifie valeur de x au point i';
hMoyenne = 'Abscisse=moyenne ; ordonne=maximum';
hEcartType = 'Abscisse=moyenne+(ecart type)';
hDemiLargeur = 'Abscisse=moyenne+(demi largeur)';
hDebutModele ='Modliser|Ouvrir le volet de modlisation';
hFinModele ='Fin modlisation|Fermer le volet de modlisation';
trSupprVar ='Suppression de %s';
hRowUnit ='|Double-clic dans l''en-tte pour modifier unit ; incertitude';
hMovePoint ='|Dplacer le point de rfrence';
hPeriode ='|Abscisse=priode ordonne=dcalage de zro';
hMaxi ='|Maximum du sinus : position et valeur';
hCteTemps ='|Abscisse=constante de temps';
hAsymptote ='; ordonne=asymptote';
hDirection = '|Direction';
hEchelle = '|Echelle';
hValeur0 ='; ordonne=valeur initiale';
hClicPage ='(double clic sur le point pour changer l''tat)';
hFreqCoupure ='abscisse : frquence caractristique';
hGainMax ='ordonne : gain maximal';
erMotdepasse='Suppression du mot de passe';
hValeurAsymptote =' 	Intersection des asymptotes';
erVttAdd ='Impossible de fusionner des fichiers LAB';
erBoucleFor ='Syntaxe de boucle for i:=exp to exp do';
erFinBoucle ='end permis en fin de boucle';
okSupprAutresPages ='Suppresssion des points de toutes les pages actives';
erDataCan ='Donnes non modifiables (voir Options Acquisition)';
erChargeOldReg ='Rechargement du dernier fichier';
okrazModele ='Remise  1 des paramtres';
okrazParam ='Suppression de la modlisation';
erForward ='Dfinir la grandeur prdfinie par x= ou x[0]=a';
okSauveOptions ='Sauvegarde des options pour tous les utilisateurs';
OkDataInf ='Pas assez de variables ; on continue';
OkDataSup ='Trop de variables : on continue';
ErGommeStat ='Slectionnez les points sur l''axe des abscisses';
hFinGomme ='Arrt de suppression de points';
erLigneNulle ='Dfinition de ligne par glisser';
erObjetGraphiqueIsole ='';
erNomObjetGraphique ='';
erFileCalc ='Nom de variables non compatibles';
erNbreData ='Pas assez de donnes';
erIndiceEuler = 'Syntaxe : x[i]= et non x[i+1]=';
erPeigneSimul = 'Peigne disponible uniquement en mode simulation';
erParamIF = 'UN argument manquant  IF(condition,si vraie,sifausse)';
erParamPW = 'Syntaxe PieceWise([test,then],else)';
erRadian = 'Passage en radian';
erVerifRadian = 'Actuellement en degr. Passage en radian ?';
erOneCol = 'Une seule colonne  la fois';
erValeurNoDef = 'Valeur non dfinie dans la page n ';
erServeur = 'Impossible de dialoguer avec le serveur';

stResiduStudent = 'Rsidu studentis ';
stLimiteStudent95 = ' (limite de Student  95% : ';
stMoyenne = 'Moyenne ';
stAnimation = 'Animation';
stFinAnimation = 'Fin animation';
stMediane = 'Mdiane ';
stEcartType = 'Ecart-type ';
stMini = 'Mini';
stMaxi = 'Maxi';
stValeur = 'Valeur ';
stMinimum = 'Minimum';
stMaximum = 'Maximum';
stIntensite = 'Intensit relative';
stCible = 'Cible ';
stTaille = 'Taille ';
stOuvrir = 'Ouvrir';
hInitialise = '|Initialise';
stUnGraphe = 'Un graphe';
stDeuxGraphes = 'Deux graphes';
stEtendue = 'Etendue : ';
stNom = 'Nom';
stSymbole = 'Symbole';
stUnite = 'Unit';
stSignif = 'Signification';
hBornes = 'Bornes PUIS expression|Dfinir un nouveau modle par un rectangle (bornes) PUIS taper la fonction';
trBornesModele = 'Bornes et nouveau modle';
stPente = 'Pente';
stPvaleur='P-valeur(';
stIntersection = 'Intersection' ;
stAngle = 'Angle';
stRayon = 'Rayon';
stAbscisse = 'Abscisse';
stOrdonnee = 'Ordonne';
stInexactitude = 'Inexactitude';
stEquivalence = 'Equivalence';
stTangente = 'Tangente';
stBorne = 'Bornes de ';
stBornes = 'Bornes';
stCourbe = 'Courbe ';
stReticule = 'Rticule';
stStatistique = 'Statistique : ';
stTableau = 'Tableau ';
stNbrePas = 'Nombre de pas : ';
stPage = 'Page';
stIncertitude = 'Incertitude';
stIncert = 'Incert. sur ';
stPages = 'Pages';
stOption = 'Option';
stPhase = 'Phase';
stPhaseContinue = 'Phase continue';
stContinu = 'Continu ';
stCouleur = 'Couleur';
stTest1 = 'Rsultat d''un rglage manuel';
stTest2 = 'des paramtres. Pour optimiser,';
stTest4 = 'Optimisation des paramtres';
stTest5 = ' effectuer';
stTest3 = 'cliquer sur ajuster';
stTest6 = 'cliquer sur le bouton "coche rouge"';
stVariables = 'Variables';
stGrandeurs = 'Grandeurs';
stModelisation = 'Modlisation';
stAxes = 'Axes';
stIteration = 'Itration n';
stIntervalle = 'me intervalle';
stDerivee = 'Drive';
stAbsolue='absolue';
stRelative='relative';
stDbDecade = 'dB/dcade';
stNbreDec ='Nombre de dcimales';
stNbreChiffres ='Nombre de chiffres';
stNbreBits ='Nombre de bits';
stFreqreduite ='Frquence rduite';
stDebutDe = ' le dbut de ';
stFinDe = ' la fin de ';
stEcartQuad = 'Ecart quad. ';
stCoeffCorrel = 'Coeff. corrlation';
stGrad = 'Grad.';
stSubdiv = 'Nbre div.';
stClicVecteur = 'Cliquer sur un point pour tracer (ou effacer) un vecteur';
stClicIndicateur = 'Clic droit pour changer d''indicateur';
stCaracStat = 'Caractristique statistique de ';
stNomVariab = 'Nom des variables :';
stFinModele = 'Fin modlisation';
stValeurReticule = 'Valeurs du rticule';
stValeurModele = 'Valeurs modlises';
stNomModele = 'Nom de la grandeur modlise';
stCommentaire = 'Commentaire';
stCalcVitesse = 'Calculer la vitesse !';
stCalcAcceleration = 'Calculer l''acclration !';
stCopiePage = 'Recopie de la page';
stGridValeurs = '&Tableau valeurs';
stRazValeurs = 'R&Z des valeurs';
stGridTangente = '&Tableau tangentes';
stRazTangente = 'R&Z des tangentes';
stResultModele = 'Rsultat de la modlisation';
stEcartRelatif = 'Ecart donnes-modle';
stTriVariab = 'Tri des donnes selon une variable';
stTriPages = 'Tri des pages selon un paramtre';
stSupprGrandeur = 'Suppression d''une grandeur';
stCadreGTS = 'Recadrage de donnes acquises par Orphy GTS';
stBorneSelect = 'Bornes  la souris|Dfinir les bornes en traant un rectangle';
stBarreReticuleFFT = '|F10: enregistre position courante'+crCR+crLF+
                     'Barre d''espace: marque le pic proche';
stBarreReticule1 = '|F10:enregistre position courante; Barre d''espace:laisse une trace (cf. clic droit tableau) ; clic:mesure d''cart ; ESC:fin';
stBarreReticule3 = '|F10:enregistre position courante'+crCR+crLF+
                   'clic:suppression deuxime curseur ; ESC:fin';
stBarreReticule2 = '|F10:enregistre position courante; clic:fixe l''cart ; ESC:fin';
stExper = ' exprimentale';
stVariable = 'Variable';
stConstante = 'Paramtre';
stParam = 'Paramtre de modlisation';
stTexte = ' texte';
stSigmaResidu = '(sigma des rsidus)';
stEcart = 'cart = ';
stComment = 'Commentaires';
stAcqBy = 'Acquisition par ';
stAjouteMod = '&Ajouter modle';
stRemplaceMod = '&Remplacer modle';
stCibleAuto = 'Cliquer sur la cible  suivre';
stNEuler = 'Nombre de points : N=';
stModif = 'modifications de ';
stData = 'donnes';
stSauve  = 'Sauvegarde des ';
stFinZoom =
'|Glisser puis relcher pour dfinir le deuxime point du rectangle dlimitant la zone concerne';
stDebutZoom =
'|Cliquer pour dfinir le premier point du rectangle dlimitant la zone concerne';
stChoixPagesGr = 'Choix des pages  regrouper en une seule';
stGroupeSuper = 'Attention : regroupe ne superpose pas';
stChoixPages = 'Choix des pages actives';
stUndo = '&Annuler suppression de ';
stNoAcces = 'Impossible d''accder  ';
stNoAccesInstall = 'Effectuer l''installation de Regressi pour accder  ';
stMajImpossible = 'Impossible d''accder au site de mise  jour';
stUndoGr = '&Annuler grouper';
stEchantillon = 'Echantillonnage';
stCaracde = 'Caractristiques de ';
stSigmay = 'Ecart-type sur ';
stImportCalc = 'Importer les traitements';
stUser = 'Utilisateur';
stName = 'Prnom nom';
stPrint = 'Impression';
stEnTete = 'En-tte';
stAVI = 'AVI';
stRepertoire = 'Repertoire';

hGommeStat = '|Slectionner  la souris (cliquer  dplacer) les points  supprimer (Ctrl enfonce pour recommencer)';
hTriDataDlg = 'tri des donnes';
hAideValide = '(validez avec Entre)';
hTriVariab = 'selon la variable slectionne';
hSupprCalc = 'les variables calcules sont supprimes';
hSupprLigne = 'en supprimant la ligne du mmo expression';
hTriPageDlg = 'tri des pages';
hTriParam = 'selon le paramtre slectionn';
hTriPhase = 'rend continue la variable slectionne';
hMod2Pi = 'en effectuant un modulo 360';
hTopSigmoide = 'Ordonne=plateau sup.';
hBottomSigmoide = 'Ordonne=plateau inf.';
hMidSigmoide = 'Point d''inflexion de la sigmode';
hPenteSigmoide = ' Ecart entre les deux points = pente';
hZoomManuelDebloq = 'Echelle bloque|Modification de l''chelle ou dblocage de celle-ci';
hZoomManuelBloq = 'Echelle manuelle|Dfinition manuelle de l''chelle et blocage de celle-ci';
hZoomAutoBloq = 'Echelle bloque => retour  l''chelle automatique';
hCopyExpressions = 'Copier expressions|Copier l''ensemble du texte dans le presse-papiers';
hCopyGrid = 'Copier tableau|Copier le tableau dans le presse-papiers';
hTriData = 'Trier donnes|Trier les donnes selon la grandeur courante';
hDelta = 'Prcision|Affiche, si enfonc, l''incertitude sur les ';
hTriPage = 'Trier page|Trier les pages selon un paramtre';
hAltTab = 'Utiliser Alt-Tab';
hGrid = '|Clic droit : menu local ; F2 : dition d''une cellule'+crCR+crLF+
        'Double-clic dans l''en-tte : modification unit, incertitude';
hCurseurOrigine ='Placer le curseur sur la nouvelle origine';
hGainContinu ='ordonne : gain en continu';
hGainHF ='ordonne : gain  haute frquence';
hGainQ ='ordonne : gain pour la frquence de coupure';
hSelectPageMod = 'Choix des pages prises en compte dans la modlisation';
hClicInsere = 'cliquer pour insrer';
hEchelleFreq = 'Cliquer dplacer les graduations pour changer l''chelle';
hBasculeGTS = 'Pour basculer vers GTS utiliser Alt-Tab ou la barre des taches';
hLigneRappel='Ligne de rappel|Style de trait des lignes de rappel';
hTraitTangente='Tangente|Style de trait des tangentes';

   TitreBmp = 'Lecture de bitmap';
   hDeplacerPoint = '|Dplacer le point';
   hRepererPoint = '|Cliquer pour enregistrer le point';
   hOrigineClick = 'Origine|Cliquer sur l''origine des axes';
   hCibleAuto = 'Cible|Cliquer sur la cible  suivre';
   trCibleAuto = 'Cliquer sur la cible  suivre';
   NoZoom = 'Taille relle';
   hTransfertRegressi = 'Transfrer vers Regressi';
   CaptionBmp = 'Lecture de bitmap pour Regressi';
   hRepereBmp = 'Cliquer sur les points  reprer';
   hSerie2Bmp = 'Deuxime srie de points';

   AcquisitionAvi = 'Acquisition  partir de video';
   erDuree = 'Dure incorrecte';
   erTronque = ' (trop long donc tronqu)';
   CaptionAvi = 'Lecture de fichier video';
   CaptionVLC = 'Lecture de fichier video par VLC';
   Captionffmpeg = 'Lecture de fichier video par ffmpeg';
   hEchelle1 = 'Dbut|Cliquer sur le dbut de l''chelle';
   hEchelle2 = 'Fin|Cliquer sur la fin de l''chelle';
   hEchelle1Move = 'Dplacer le dbut de l''chelle';
   hEchelle2Move = 'Dplacer la fin de l''chelle';

   hGlisserEchelle = '|Glisser jusqu'' la fin de l''chelle';
   hMesureAviN = '|Cliquer sur le %dime point de l''image n %d';
   hMesureAvi1N = '|Cliquer sur le premier point de l''image n %d';
   hMesureAvi1 = '|Cliquer sur le point  reprer (image n %d)';
   hStartRecord = 'Enregistre|Dbut de l''enregistrement';
   hStopRecord = 'Stop|Fin de l''enregistrement';
   hClicDroitAvi = 'Clic droit pour choix du curseur';
   hChronoEnCours = 'Patientez';
   hEchelleJpeg = '|Echelle ; double-clic pour agrandir';
   hParamBtn = 'Cliquer sur le bouton Paramtres pour configurer';
   hvidcap = '|Lecture du fichier captur par ';
   hOrigineI = '|Cliquer sur l''origine du point n';
   hOrigineMobile = '|Il faudra indiquer l''origine avant chaque point';
   hOrigineMouse = '|Indique l''origine  l''aide de la souris';
   hStopMes = '|Arrt des mesures';
   hStartMes = '|Commencer les mesures';
   hStopChrono = '|Arrt de la Chronophotographie';
   hChrono = '|Raliser une chronophotographie';
   hOrigine1 = 'Origine du point n1';
   hOrigineT = 'cliquer sur le point origine des temps';
   hClicPoint = 'cliquer sur le point  enregistrer';
   trEchelle = 'Echelle';
   trLmetre = 'Longueur en mtre ?';

   DeplacerPoint = '|Dplacer le point';
   hOrigineMove = 'Dplacer l''origine';
   hNoZoom = 'Taille relle';
   hSupprPoint = '|Suppression du point';
   hReglerZoom = 'Dplacer le rectangle de visualisation'+crCR+crLF+
                 'Taille rglable par barre en bas  gauche.';
   hDebutX  = 'Dbut X|Cliquer sur le dbut de l''chelle horizontale de ';
   hFinX  = 'Fin X|Cliquer sur la fin de l''chelle horizontale de ';
   hDebutY  = 'Dbut Y|Cliquer sur le dbut de l''chelle verticale de ';
   hFinY  = 'Fin Y|Cliquer sur la fin de l''chelle verticale de ';
   hDebutEch  = 'Dplacer le dbut de l''chelle';
   hFinEch  = 'Dplacer la fin de l''chelle';
   hMesureAviAngle1 = '|Cliquer sur la direction de rfrence (image n %d)';
   hMesureAviAngle2 = '|Cliquer sur l''origine de l''angle (image n %d)';
   hMesureAviAngle3 = '|Cliquer sur la direction  reprer (image n %d)';

   trDimPixel = 'Dimension d''un pixel';
   trLongEchelle = 'Longueur de l''chelle';
   trOrigineEchelle = 'Origine de l''chelle';
   trDistance = 'distance=';

   erPointsProches = 'Points trop proches';
   erBass = 'Bass.dll non trouv';

   erUnMobileAuto = 'Un seul mobile possible en mode automatique';
   trOrigineTemps = 'L''image courante sera l''origine des temps';
   trOrigineAxe = 'Cliquer sur le point  l''origine des axes';
   trAideEchelle = 'Cliquer sur le premier point puis sur le deuxime de l''chelle';
   trAideAngle = 'Trois points par image'+crCR+crLF+
                 'point sur la base, sommet de l''angle, point final (dans cet ordre)';

   CaptionWav = 'Regressi : lecture de fichier son';
   erFormatWav = 'Format du fichier WAV non reconnu';
   TrDuree = 'Dure=';
   TrFrequence = 'Fech=';
   TrDureeMax = 'Sous chantillonnage si la dure excde ';


implementation

end.


