object ArduinoOscilloDlg: TArduinoOscilloDlg
  Left = 0
  Top = 0
  HelpContext = 80
  BorderIcons = [biSystemMenu, biMinimize, biMaximize, biHelp]
  Caption = 'Param'#233'trage liaison s'#233'rie Arduino'
  ClientHeight = 478
  ClientWidth = 343
  Color = clBtnFace
  Font.Charset = DEFAULT_CHARSET
  Font.Color = clWindowText
  Font.Height = -11
  Font.Name = 'Segoe UI'
  Font.Style = []
  OldCreateOrder = False
  OnActivate = FormActivate
  PixelsPerInch = 96
  TextHeight = 13
  object Comports: TRadioGroup
    Left = 0
    Top = 0
    Width = 343
    Height = 40
    Align = alTop
    Caption = 'Voie s'#233'rie:'
    Columns = 4
    ItemIndex = 0
    Items.Strings = (
      'Com1'
      'Com2'
      'Com3'
      'Com4')
    TabOrder = 0
    OnClick = ComportsClick
  end
  object OKBtn: TBitBtn
    Left = 8
    Top = 444
    Width = 80
    Height = 25
    Kind = bkOK
    NumGlyphs = 2
    TabOrder = 1
  end
  object Memo1: TMemo
    Left = 0
    Top = 80
    Width = 343
    Height = 169
    Align = alTop
    Lines.Strings = (
      'Le logiciel s'#39'attend '#224' ce que Arduino envoie des lignes de '
      'donn'#233'es, les donn'#233'es '#233'tant s'#233'par'#233'es par des virgules,'
      'la premi'#232're donn'#233'e '#233'tant le temps qui sera plac'#233' en abscisse.'
      'La vitesse doit '#234'tre r'#233'gl'#233'e '#224' x baud par Serial.begin(x);'
      'On a pr'#233'vu une fr'#233'quence d'#39#233'chantillonnage maxi de 100 kHz.'
      'Attention, dans la cas de Arduino Uno, elle est limit'#233'e '#224' 5 kHZ.'
      
        'Les donn'#233'es sont cens'#233'es '#234'tre des entiers positifs sur 10 bits, ' +
        'la '
      
        'conversion se faisant '#224' l'#39'aide de la troisi'#232'me ligne pour laquel' +
        'le '
      'cette valeur enti'#232're est not'#233'e V.'
      'Exemple conversion vers 0..5V : 5*V/1024'
      'Pour le sur'#233'chantillonnage, il faut respecter le crit'#232're de '
      'Shannon (pas de signal carr'#233' !)')
    ReadOnly = True
    TabOrder = 2
  end
  object UnoBtn: TBitBtn
    Left = 8
    Top = 351
    Width = 200
    Height = 25
    Caption = 'Exemple Arduino Uno'
    Kind = bkHelp
    NumGlyphs = 2
    TabOrder = 3
    OnClick = UnoBtnClick
  end
  object BaudRG: TRadioGroup
    Left = 0
    Top = 40
    Width = 343
    Height = 40
    Align = alTop
    Caption = 'Vitesse/baud'
    Columns = 5
    ItemIndex = 0
    Items.Strings = (
      '9600'
      '19200'
      '38400'
      '57600'
      '115200')
    TabOrder = 4
    OnClick = BaudRGClick
  end
  object CurieBtn: TBitBtn
    Left = 8
    Top = 382
    Width = 200
    Height = 25
    Caption = 'Exemple Arduino Curie 101'
    Kind = bkHelp
    NumGlyphs = 2
    TabOrder = 5
    OnClick = UnoBtnClick
  end
  object DueBtn: TBitBtn
    Left = 8
    Top = 413
    Width = 200
    Height = 25
    Caption = 'Exemple Arduino Due'
    Kind = bkHelp
    NumGlyphs = 2
    TabOrder = 6
    OnClick = UnoBtnClick
  end
  object arduinoExeBtn: TBitBtn
    Left = 180
    Top = 444
    Width = 160
    Height = 25
    Caption = 'Lancer IDE Arduino'
    Glyph.Data = {
      66010000424D6601000000000000760000002800000014000000140000000100
      040000000000F000000000000000000000001000000000000000000000000000
      8000008000000080800080000000800080008080000080808000C0C0C0000000
      FF0000FF000000FFFF00FF000000FF00FF00FFFF0000FFFFFF00333333333333
      3333333300003333333133333333333300003333333013333333333300003333
      3331013333333333000033333331901333333333000033333331990133333333
      0000333333319990133333330000333333319999013333330000333333319999
      9013333300003333333199999901333300003333333199999990333300003333
      3331999999033333000033333331999990333333000033333331999903333333
      0000333333319990333333330000333333319903333333330000333333319033
      3333333300003333333103333333333300003333333033333333333300003333
      33333333333333330000}
    TabOrder = 7
    OnClick = arduinoExeBtnClick
  end
  object HelpBtn: TBitBtn
    Left = 94
    Top = 444
    Width = 80
    Height = 25
    Caption = 'Aide'
    Default = True
    Glyph.Data = {
      66010000424D6601000000000000760000002800000014000000140000000100
      040000000000F000000000000000000000001000000000000000000000000000
      80000080000000808000800000008000800080800000C0C0C000808080000000
      FF0000FF000000FFFF00FF000000FF00FF00FFFF0000FFFFFF00333333333333
      3333333300003333333333333333333300003333333BBBBB3333333300003333
      3BBB191BBB33333300003333BBBB999BBBB333330000333BBBBB191BBBBB3333
      000033BBBBBBBBBBBBBBB333000033BBBBBBB9BBBBBBB33300003BBBBBBBB91B
      BBBBBB3300003BBBBBBBB99BBBBBBB3300003BBBBBBBBB99BBBBBB3300003BBB
      BB11BB199BBBBB3300003BBBBB99BB199BBBBB33000033BBBB991B199BBBB333
      000033BBBBB99999BBBBB3330000333BBBBB999BBBBB333300003333BBBBBBBB
      BBB33333000033333BBBBBBBBB33333300003333333BBBBB3333333300003333
      33333333333333330000}
    ModalResult = 9
    TabOrder = 8
    OnClick = HelpBtnClick
  end
  object sincGB: TGroupBox
    Left = 0
    Top = 249
    Width = 343
    Height = 88
    Align = alTop
    Caption = 'Options d'#39'acquisition'
    TabOrder = 9
    object ResolutionCB: TCheckBox
      Left = 214
      Top = 58
      Width = 126
      Height = 17
      Caption = '12 bits (Due, Zero ...)'
      TabOrder = 0
    end
    object sincCB: TCheckBox
      Left = 8
      Top = 58
      Width = 132
      Height = 17
      Caption = 'Sur'#233'chantillonnage x '
      TabOrder = 1
    end
    object ordreSincSE: TSpinEdit
      Left = 140
      Top = 58
      Width = 50
      Height = 22
      MaxValue = 12
      MinValue = 2
      TabOrder = 2
      Value = 2
    end
    object NbreRG: TRadioGroup
      Left = 2
      Top = 15
      Width = 339
      Height = 40
      Align = alTop
      Caption = 'Nombre de points'
      Columns = 4
      ItemIndex = 0
      Items.Strings = (
        '300'
        '512'
        '1024'
        '2048')
      TabOrder = 3
    end
  end
end
