unit ConversionVideo;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, Vcl.ComCtrls,
  regutil, Vcl.StdCtrls;

type
  TAttenteConversionDlg = class(TForm)
    TaillePB: TProgressBar;
    Timer1: TTimer;
    Button1: TButton;
    procedure Timer1Timer(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    taille : int64;
  public
    Anom : string;
    tailleInit : int64;
  end;

var
  AttenteConversionDlg: TAttenteConversionDlg;

implementation

{$R *.dfm}

procedure TAttenteConversionDlg.FormActivate(Sender: TObject);
begin
    TaillePB.Max := tailleInit div 1024;
    taille := -1;
end;

procedure TAttenteConversionDlg.Timer1Timer(Sender: TObject);
var oldTaille : int64;
begin
       oldTaille := taille;
       taille := tailleFichier(Anom);
       TaillePB.Position := taille div 1024;
       if (taille=oldTaille) and (taille>0) then
          modalResult := mrOK;
end;

end.
