unit conversion;

interface

uses
  System.Types, System.UITypes, System.ImageList,
  Windows, SysUtils, Messages,  Classes, Graphics, Controls,
  Forms,  Dialogs, StdCtrls,  ExtCtrls,  Buttons,
  ComCtrls, ToolWin, system.IOutils,
  regutil, constreg,  shellApi;

type
  TConversionForm = class(TForm)
    OpenDialog: TOpenDialog;
    Memo1: TMemo;
    ConvertBtn: TBitBtn;
    StopBtn: TBitBtn;
    ExitBtn: TBitBtn;
    Label1: TLabel;
    procedure ExitBtnClick(Sender: TObject);
    procedure OpenFileBtnClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure StopBtnClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
  public
  protected
  end;

var
  ConversionForm: TConversionForm;

implementation

uses regmain;

{$R *.DFM}

procedure TConversionForm.ExitBtnClick(Sender: TObject);
begin
    Close
end;

procedure TConversionForm.OpenFileBtnClick(Sender: TObject);
var destination : string;
begin
   if OpenDialog.execute then begin
      stopBtn.Enabled := true;
      destination := openDialog.fileName;
      if convertirVideo(destination)
         then label1.Caption := destination
         else showMessage('Impossible de convertir le fichier');
      stopBtn.Enabled := false;
   end;
end;

procedure TConversionForm.StopBtnClick(Sender: TObject);
begin
    arretConversionVideo := true;
end;

procedure TConversionForm.FormActivate(Sender: TObject);
begin
  (*  if pos('prism',nomDecodeur)>0 then
       label1.Caption := 'prism : rpertoire de destination='+tempDirReg;
       *)
    if pos('mencoder',nomDecodeur)>0  then
       label1.Caption := 'mecoder : rpertoire de destination='+tempDirReg;
    if pos('ffmpeg',nomDecodeur)>0
       then label1.Caption := 'ffmpeg : passage de l''extension avi  mpg et rciproquement';
end;

procedure TConversionForm.FormDestroy(Sender: TObject);
begin
     conversionForm := nil
end;

end.

