unit printgrid;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, Buttons, tradformnew;

type
  TPrintGridDlg = class(TtradForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    PasSpinEdit: TSpinEdit;
    Label2: TLabel;
    NligneLabel: TLabel;
    procedure FormActivate(Sender: TObject);
    procedure PasSpinEditChange(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
  public
    NbreLignes : integer;
    PasDefaut : integer;
  end;

var
  PrintGridDlg: TPrintGridDlg;

implementation

{$R *.DFM}

procedure TPrintGridDlg.FormActivate(Sender: TObject);
begin
      inherited;
      PasSpinEdit.value := pasDefaut;
      PasSpinEdit.minValue := pasDefaut div 4; { 256 lignes }
      PasSpinEdit.maxValue := 2*pasDefaut; { 32 lignes }
end;

procedure TPrintGridDlg.PasSpinEditChange(Sender: TObject);
begin
     NligneLabel.caption := intToStr(NbreLignes div PasSpinEdit.value)+' lignes'
end;

procedure TPrintGridDlg.BitBtn2Click(Sender: TObject);
begin
   if MessageDlg('Impression de '+intToStr(NbreLignes)+
       ' lignes ?', mtConfirmation,
      [mbYes, mbNo], 0) = mrYes
        then PasSpinEdit.value := 1
        else modalResult := mrAbort
end;

procedure TPrintGridDlg.BitBtn1Click(Sender: TObject);
begin
    if (PasSpinEdit.value<pasDefaut) and
       (MessageDlg('Impression de '+intToStr(NbreLignes div PasSpinEdit.value)+
          ' lignes ?', mtConfirmation,
          [mbYes, mbNo], 0) = mrNo)
        then modalResult := mrAbort
end;

end.
